// Code by Amnon Jonas, modified from Jed Brown nanatool http://jedbrown.net/
// Modified version from PastQuote by Cusser http://cusser.net/extensions/.//
// Cusser writes beautiful code, I tend to take such code and make it shit. Please forgive me.
//##################################################################################### 
//License: Please feel free to use this code for your extension/program (open source or comercial)
// No GPL, no MPL, just a few rules.
// 1) If you use any of this code please include references or credit in your code to both myself (Jed Brown) and Cusser, and include our URL's
// 2) You MUST contact me, the author before you use this code(I like to know that it's been usefull).
// 3) I would greatly appreciate a link back to me or credit somewhere on your site (makes me feel good).
// 4) If improvments are made to the code, please inform me so that I can use it (if applicable).
//#####################################################################################
var NanaTool_Color;
var gPreferences;
var NanaTool_enableNanaTool;
var NanaTool_enableXHTML;
var NanaTool_enableHTML;
var NanaTool_stringBundle;
var NanaTool_Document = null;
//Set Defaults
getPrefNanaToolCompose().SetDefaultBoolPref("nanatool.contextmenu.nanatool", true);
getPrefNanaToolCompose().SetDefaultBoolPref("nanatool.contextmenu.xhtml", false);
getPrefNanaToolCompose().SetDefaultBoolPref("nanatool.contextmenu.html", false);
getPrefNanaToolCompose().SetDefaultCharPref("nanatool.font.color", "#000000");
getPrefNanaToolCompose().SetDefaultCharPref("nanatool.font.size", "12");
NanaTool_Size = getPrefNanaToolCompose().GetCharPref("nanatool.font.size");
NanaTool_Color = getPrefNanaToolCompose().GetCharPref("nanatool.font.color");
NanaTool_enableNanaTool = getPrefNanaToolCompose().GetBoolPref("nanatool.contextmenu.nanatool");
NanaTool_enableXHTML = getPrefNanaToolCompose().GetBoolPref("nanatool.contextmenu.xhtml");
NanaTool_enableHTML = getPrefNanaToolCompose().GetBoolPref("nanatool.contextmenu.html");

var nanatool = {
	init: function() {
    NanaTool_setupDocument(document);
    try{
      var menu = document.getElementById('contentAreaContextMenu');
      menu.addEventListener('popupshowing', nanatool.showHide, false);
    }catch (e){
      //Foobar!
    }
	},
	showHide: function() {
		if(NanaTool_enableNanaTool){
      document.getElementById('context-nanatool').hidden = document.getElementById('context-undo').hidden;
    }else{
      document.getElementById('context-nanatool').hidden = true;
    }
    if(NanaTool_enableXHTML){
      document.getElementById('context-nanatool-xhtml').hidden = document.getElementById('context-undo').hidden;
    }else{
      document.getElementById('context-nanatool-xhtml').hidden = true;
    }
    if(NanaTool_enableHTML){
      document.getElementById('context-nanatool-html').hidden = document.getElementById('context-undo').hidden;
    }else{
      document.getElementById('context-nanatool-html').hidden = true;
    }
	},
	nanatool: function(myCommand, codeType) {
    var clip = Components.classes["@mozilla.org/widget/clipboard;1"].createInstance(Components.interfaces.nsIClipboard);
    if (!clip){
      return false;
    }
    
    var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
    if (!trans){
      return false;
    }
    
      trans.addDataFlavor("text/unicode");
      clip.getData(trans,clip.kGlobalClipboard);

    
    var str = null;
    var str_clipboard=new Object();
    var strLength=new Object();
    try{
      trans.getTransferData("text/unicode",str_clipboard,strLength);
  
  
      if (str_clipboard){
        str_clipboard=str_clipboard.value.QueryInterface(Components.interfaces.nsISupportsString);
      }
      if (str_clipboard){
        pastetext=str_clipboard.data.substring(0,strLength.value / 2);
      }
    }catch (e){
      //alert("No text in the clipboard, please copy something first.");
    }
    
		var theBox = document.commandDispatcher.focusedElement;
		var oPosition = theBox.scrollTop;
		var oHeight = theBox.scrollHeight;
    
    
    //Get Selected text (if selected)
      var startPos = theBox.selectionStart;
      var endPos = theBox.selectionEnd;
      str = theBox.value.substring(startPos, endPos);
      //alert("Str: " +str);
 
      if(codeType == "nanatool"){
        nanatool.insertAtCursorSetup(myCommand, str_clipboard, str, theBox);
      }else if(codeType == "html"){
        nanatool.insertAtCursorSetupHTML(myCommand, str_clipboard, str, theBox);
      }else if(codeType == "xhtml"){
        nanatool.insertAtCursorSetupXHTML(myCommand, str_clipboard, str, theBox);
      }else{
        alert("Error #1");
      }
		var nHeight = theBox.scrollHeight - oHeight;
		theBox.scrollTop = oPosition + nHeight;
	},
  
  	insertAtCursorSetup: function(myCommand, str_clipboard, str, theBox) {
  // Function taken from http://www.alexking.org/blog/2003/06/02/inserting-at-the-cursor-using-javascript/
  // Modified to return cursor to correct place
    switch (myCommand){
      case "quoteclip":
        nanatool.insertAtCursor(theBox,"[quote]" + str_clipboard + "[/quote]");
        break;
        
      case "quote":
        nanatool.insertAtCursor(theBox,"[quote]" + str + "[/quote]");
        break;
        
      case "img":
        nanatool.insertAtCursor(theBox,"[img]" + str_clipboard + "[/img]");
        break;
        
      case "url":
        nanatool.insertAtCursor(theBox,"[url]" + str_clipboard + "[/url]");
        break;
        
      case "urlclip":
        nanatool.insertAtCursor(theBox,"[url=" + str_clipboard + "]" + str + "[/url]");
        break;
        
      case "bold":
        nanatool.insertAtCursor(theBox,"[b]" + str + "[/b]");
        break;
        
      case "italic":
        nanatool.insertAtCursor(theBox,"[i]" + str + "[/i]");
        break;
        
      case "underline":
        nanatool.insertAtCursor(theBox,"[u]" + str + "[/u]");
        break;
        
      case "code":
        nanatool.insertAtCursor(theBox,"[code]" + str + "[/code]");
        break;
        
      case "urlcode":
        nanatool.insertAtCursor(theBox,"[code]" + str_clipboard + "[/code]");
        break;
        
      case "list":
        var listElements = " ";
        var listString = "";
        while(listElements != "" && listElements != null){ 
          var alertText = NanaTool_stringBundle.getString("nanatool.list");
          listElements = prompt(alertText);
          if(listElements != "" && listElements != null ){
            listString = listString + "\n[*]" +listElements;
          }
        }
        if(listElements != null){
          nanatool.insertAtCursor(theBox,"[list]"  + listString + "[/list]");
        }
        break;  
      
      case "size":
        var re = [];
        var nanatoolsize = [NanaTool_Size];
        window.openDialog("chrome://nanatool/content/nanatoolsize.xul", "NanaToolSize","chrome,modal,centerscreen",re,nanatoolsize);
        if(re[0]){
          nanatool.insertAtCursor(theBox,"[size=" + nanatoolsize[0] + "]" + str + "[/size]");
          NanaTool_Size = nanatoolsize[0];
        }
        break;

      case "color":
        var re = [];
        var nanatoolcolor = [NanaTool_Color];
        window.openDialog("chrome://nanatool/content/nanatoolcolor.xul", "NanaToolColor","chrome,modal,centerscreen",re,nanatoolcolor);
        if(re[0]){
          nanatool.insertAtCursor(theBox,"[color=" + nanatoolcolor[0] + "]" + str + "[/color]");
          NanaTool_Color = nanatoolcolor[0];
        }
        break;
        
        //End NANATOOL       
        // Start NANATOOL Smiles
      
case "151084": 
nanatool.insertAtCursor(theBox,":-)");
        break;
case "151085": 
nanatool.insertAtCursor(theBox,":-(");
        break;
case "151088": 
nanatool.insertAtCursor(theBox,"0-:");
        break;
case "151087": 
nanatool.insertAtCursor(theBox,";-)");
        break;
case "151089": 
nanatool.insertAtCursor(theBox,",:(");
        break;
case "151090": 
nanatool.insertAtCursor(theBox,"8-)");
        break;
case "151091": 
nanatool.insertAtCursor(theBox,":-*");
        break;
case "491027": 
nanatool.insertAtCursor(theBox,":-D");
        break;
case "517211": 
nanatool.insertAtCursor(theBox,":-/");
        break;
case "151092": 
nanatool.insertAtCursor(theBox,":,(");
        break;
case "151093": 
nanatool.insertAtCursor(theBox,"~\u05DC\u05E9\u05D5\u05DF~");
        break;
case "151094": 
nanatool.insertAtCursor(theBox,"~devil~");
        break;
case "517217": 
nanatool.insertAtCursor(theBox,"~\u05D0\u05D5\u05D4\u05D1~");
        break;
case "151095": 
nanatool.insertAtCursor(theBox,"~\u05D0\u05D3\u05D5\u05DD~");
        break;
case "151096": 
nanatool.insertAtCursor(theBox,"~\u05DB\u05D7\u05D5\u05DC~");
        break;
case "151097": 
nanatool.insertAtCursor(theBox,"~\u05EA\u05DC\u05DE\u05D9\u05D3~");
        break;
case "151098": 
nanatool.insertAtCursor(theBox,"~zzz~");
        break;
case "151099": 
nanatool.insertAtCursor(theBox,"~\u05EA\u05D5\u05D3\u05D4~");
        break;
case "151100": 
nanatool.insertAtCursor(theBox,"~\u05D9\u05DC\u05D3~");
        break;
case "151101": 
nanatool.insertAtCursor(theBox,"~\u05DC\u05D1~");
        break;
case "151102": 
nanatool.insertAtCursor(theBox,"~\u05E9\u05D1\u05D5\u05E8~");
        break;
case "151103": 
nanatool.insertAtCursor(theBox,"~up~");
        break;
case "151104": 
nanatool.insertAtCursor(theBox,"~down~");
        break;
case "151105": 
nanatool.insertAtCursor(theBox,"~\u05E7\u05D8\u05DF~");
        break;
case "151107": 
nanatool.insertAtCursor(theBox,"~\u05E4\u05D9\u05D4\u05D5\u05E7~");
        break;
case "151108": 
nanatool.insertAtCursor(theBox,"~\u05D7\u05D9\u05D1\u05D5\u05E7~");
        break;
case "151109": 
nanatool.insertAtCursor(theBox,"~\u05E6\u05D7\u05E7\u05D5\u05E7~");
        break;
case "151110": 
nanatool.insertAtCursor(theBox,"~lol~");
        break;
case "151111": 
nanatool.insertAtCursor(theBox,"~\u05DB\u05DC\u05D1~");
        break;
case "151112": 
nanatool.insertAtCursor(theBox,"~\u05D7\u05EA\u05D5\u05DC~");
        break;
case "151113": 
nanatool.insertAtCursor(theBox,"~\u05D0\u05E4\u05E8\u05D5\u05D7~");
        break;
case "151114": 
nanatool.insertAtCursor(theBox,"~\u05EA\u05E8\u05E0\u05D2\u05D5\u05DC~");
        break;
case "151115": 
nanatool.insertAtCursor(theBox,"~\u05D0\u05D5\u05D5\u05D6~");
        break;
case "151116": 
nanatool.insertAtCursor(theBox,"~\u05D3\u05D2~");
        break;
case "151121": 
nanatool.insertAtCursor(theBox,"~\u05E2\u05DB\u05D1\u05E8~");
        break;
case "151122": 
nanatool.insertAtCursor(theBox,"~\u05DB\u05D1\u05E9\u05D4~");
        break;
case "151123": 
nanatool.insertAtCursor(theBox,"~\u05E4\u05E8\u05D4~");
        break;
case "151124": 
nanatool.insertAtCursor(theBox,"~\u05E4\u05D9\u05DC~");
        break;
case "151125": 
nanatool.insertAtCursor(theBox,"~\u05D0\u05E8\u05E0\u05D1~");
        break;
case "151126": 
nanatool.insertAtCursor(theBox,"~\u05D9\u05D5\u05E0\u05D4~");
        break;
case "151127": 
nanatool.insertAtCursor(theBox,"~\u05E6\u05D1~");
        break;
case "151128": 
nanatool.insertAtCursor(theBox,"~\u05D2\u05DE\u05DC~");
        break;
case "151129": 
nanatool.insertAtCursor(theBox,"~\u05E7\u05D9\u05E4\u05D5\u05D3~");
        break;
case "151130": 
nanatool.insertAtCursor(theBox,"~\u05D7\u05D9\u05DC\u05D6\u05D5\u05DF~");
        break;
case "151131": 
nanatool.insertAtCursor(theBox,"~\u05E2\u05D8\u05DC\u05E3~");
        break;
case "491665": 
nanatool.insertAtCursor(theBox,"~\u05E4\u05E8\u05E4\u05E8~");
        break;
case "151132": 
nanatool.insertAtCursor(theBox,"~\u05D7\u05D6\u05D9\u05E8~");
        break;
case "151133": 
nanatool.insertAtCursor(theBox,"~\u05D3\u05D2\u05DC~");
        break;
case "151134": 
nanatool.insertAtCursor(theBox,"~\u05D2\u05D0\u05D5\u05D5\u05D4~");
        break;
case "151135": 
nanatool.insertAtCursor(theBox,"~jack~");
        break;
case "151138": 
nanatool.insertAtCursor(theBox,"~\u05E0\u05E2\u05E0\u05E2~");
        break;
case "151139": 
nanatool.insertAtCursor(theBox,"~\u05DE\u05D3\u05D0~");
        break;
case "151140": 
nanatool.insertAtCursor(theBox,"~\u05E9\u05DC\u05D5\u05DD~");
        break;
case "151141": 
nanatool.insertAtCursor(theBox,"~\u05E1\u05E8\u05D8\u05D0\u05D3\u05D5\u05DD~");
        break;
case "151142": 
nanatool.insertAtCursor(theBox,"~\u05DC\u05E1\u05D1\u05D9\u05EA~");
        break;
case "151143": 
nanatool.insertAtCursor(theBox,"~\u05D2\u05D9\u05D9~");
        break;
case "151144": 
nanatool.insertAtCursor(theBox,"~\u05D7\u05DE\u05E1\u05D4~");
        break;
case "151146": 
nanatool.insertAtCursor(theBox,"~\u05E1\u05E0\u05D9\u05E5~");
        break;
case "491006": 
nanatool.insertAtCursor(theBox,"~\u05D9\u05DF~");
        break;
case "517220": 
nanatool.insertAtCursor(theBox,"~\u05E9\u05D9\u05D7\u05D4~");
        break;
case "151147": 
nanatool.insertAtCursor(theBox,"~tux~");
        break;
case "151148": 
nanatool.insertAtCursor(theBox,"~\u05E9\u05DE\u05E9~");
        break;
case "151149": 
nanatool.insertAtCursor(theBox,"~\u05D9\u05E8\u05D7~");
        break;
case "151150": 
nanatool.insertAtCursor(theBox,"~\u05D1\u05E8\u05E7~");
        break;
case "151151": 
nanatool.insertAtCursor(theBox,"~\u05DE\u05E2\u05D5\u05E0\u05DF~");
        break;
case "151152": 
nanatool.insertAtCursor(theBox,"~\u05D2\u05E9\u05DD~");
        break;
case "151153": 
nanatool.insertAtCursor(theBox,"~\u05E2\u05E0\u05DF~");
        break;
case "151156": 
nanatool.insertAtCursor(theBox,"~ot~");
        break;
case "151157": 
nanatool.insertAtCursor(theBox,"~spoiler~");
        break;
case "151158": 
nanatool.insertAtCursor(theBox,"~tip~");
        break;
case "151159": 
nanatool.insertAtCursor(theBox,"~duh~");
        break;
case "151160": 
nanatool.insertAtCursor(theBox,"~huh~");
        break;
case "517251": 
nanatool.insertAtCursor(theBox,"~\u05D2\u05E8\u05E8~");
        break;
case "151161": 
nanatool.insertAtCursor(theBox,"~\u05E4\u05E8\u05E1\u05D5\u05DE\u05EA~");
        break;
case "151162": 
nanatool.insertAtCursor(theBox,"~\u05D1\u05D9\u05E7\u05D5\u05E8\u05EA~");
        break;
case "151163": 
nanatool.insertAtCursor(theBox,"~\u05D4\u05DE\u05DC\u05E6\u05D4~");
        break;
case "151164": 
nanatool.insertAtCursor(theBox,"~\u05DE\u05EA\u05DB\u05D5\u05DF~");
        break;
case "151165": 
nanatool.insertAtCursor(theBox,"~\u05D0\u05D6\u05D4\u05E8\u05D4~");
        break;
case "151166": 
nanatool.insertAtCursor(theBox,"~\u05DC\u05E4~");
        break;
case "151167": 
nanatool.insertAtCursor(theBox,"~cult~");
        break;
case "151170": 
nanatool.insertAtCursor(theBox,"~\u05D0\u05D9\u05E8\u05D5\u05E0\u05D9\u05D4~");
        break;
case "151171": 
nanatool.insertAtCursor(theBox,"~nd~");
        break;
case "151172": 
nanatool.insertAtCursor(theBox,"~hear~");
        break;
case "397553": 
nanatool.insertAtCursor(theBox,"~euro~");
        break;
case "151173": 
nanatool.insertAtCursor(theBox,"~rtfm~");
        break;
case "151174": 
nanatool.insertAtCursor(theBox,"~\u05D1\u05E4~");
        break;
case "151175": 
nanatool.insertAtCursor(theBox,"~\u05D1\u05DE~");
        break;
case "151176": 
nanatool.insertAtCursor(theBox,"~\u05E4\u05E8\u05D7~");
        break;
case "151177": 
nanatool.insertAtCursor(theBox,"~!~");
        break;
case "151178": 
nanatool.insertAtCursor(theBox,"~\u05E4\u05E6\u05E6\u05D4~");
        break;
case "151179": 
nanatool.insertAtCursor(theBox,"~\u05EA\u05DC\u05EA\u05DF~");
        break;
case "151180": 
nanatool.insertAtCursor(theBox,"~\u05E4\u05E8\u05E1\u05D4~");
        break;
case "151181": 
nanatool.insertAtCursor(theBox,"~\u05E0\u05E8~");
        break;
case "151182": 
nanatool.insertAtCursor(theBox,"~\u05E4\u05D7~");
        break;
case "151183": 
nanatool.insertAtCursor(theBox,"~\u05D0\u05E7\u05DE\u05D5\u05DC~");
        break;
case "151184": 
nanatool.insertAtCursor(theBox,"~\u05DB\u05D5\u05D1\u05E2~");
        break;
case "406243": 
nanatool.insertAtCursor(theBox,"~\u05E7\u05E4\u05D4~");
        break;
case "517244": 
nanatool.insertAtCursor(theBox,"~\u05EA\u05D4~");
        break;
case "151185": 
nanatool.insertAtCursor(theBox,"~\u05E1\u05E8\u05D8~");
        break;
case "151186": 
nanatool.insertAtCursor(theBox,"~\u05DE\u05D5\u05E6\u05E5~");
        break;
case "151187": 
nanatool.insertAtCursor(theBox,"~\u05D1\u05DC\u05D5\u05DF~");
        break;
case "151188": 
nanatool.insertAtCursor(theBox,"~\u05D1\u05DC\u05D5\u05DF\u05DB\u05D7\u05D5\u05DC~");
        break;
case "491011": 
nanatool.insertAtCursor(theBox,"~\u05E2\u05D5\u05D2\u05DF~");
        break;
case "491022": 
nanatool.insertAtCursor(theBox,"~\u05E9\u05E2\u05D5\u05DF~");
        break;
case "533505": 
nanatool.insertAtCursor(theBox,"~\u05DB\u05D3\u05D5\u05E8\u05D2\u05DC~");
        break;
case "491028": 
nanatool.insertAtCursor(theBox,"~\u05D0\u05D1\u05D8\u05D9\u05D7~");
        break;
case "491023": 
nanatool.insertAtCursor(theBox,"~\u05E2\u05E0\u05D1\u05D9\u05DD~");
        break;
case "517226": 
nanatool.insertAtCursor(theBox,"~\u05D1\u05E0\u05E0\u05D4~");
        break;
case "517222": 
nanatool.insertAtCursor(theBox,"~\u05EA\u05E4\u05D5\u05D6~");
        break;
case "491029": 
nanatool.insertAtCursor(theBox,"~\u05DC\u05D7\u05DD~");
        break;
case "517231": 
nanatool.insertAtCursor(theBox,"~\u05E0\u05D1\u05DC~");
        break;
case "491030": 
nanatool.insertAtCursor(theBox,"~\u05D0\u05D5\u05E4\u05E0\u05D9\u05D9\u05DD~");
        break;
case "151189": 
nanatool.insertAtCursor(theBox,"~\u05EA\u05E4\u05D5\u05D7~");
        break;
case "151190": 
nanatool.insertAtCursor(theBox,"~\u05E8\u05D9\u05DE\u05D5\u05DF~");
        break;
case "151202": 
nanatool.insertAtCursor(theBox,"~\u05E8\u05D0\u05E9\u05D3\u05D2~");
        break;
case "151203": 
nanatool.insertAtCursor(theBox,"~\u05DC\u05D7\u05D9\u05D9\u05DD~");
        break;
case "151191": 
nanatool.insertAtCursor(theBox,"~\u05EA\u05D5\u05E8\u05D4~");
        break;
case "151192": 
nanatool.insertAtCursor(theBox,"~\u05D7\u05E0\u05D5\u05DB\u05D9\u05D4~");
        break;
case "151193": 
nanatool.insertAtCursor(theBox,"~\u05D7\u05D2\u05DE\u05D5\u05DC\u05D3~");
        break;
case "151194": 
nanatool.insertAtCursor(theBox,"~\u05DC\u05D9\u05E6\u05DF1~");
        break;
case "151195": 
nanatool.insertAtCursor(theBox,"~\u05DC\u05D9\u05E6\u05DF2~");
        break;
case "151196": 
nanatool.insertAtCursor(theBox,"~\u05D0\u05D5\u05D6\u05DF~");
        break;
case "151197": 
nanatool.insertAtCursor(theBox,"~\u05E8\u05E2\u05E9\u05DF~");
        break;
case "151198": 
nanatool.insertAtCursor(theBox,"~\u05DE\u05E1\u05DB\u05D4~");
        break;
case "151199": 
nanatool.insertAtCursor(theBox,"~\u05E4\u05E8\u05E2\u05D4~");
        break;
case "151200": 
nanatool.insertAtCursor(theBox,"~\u05DE\u05E9\u05D4~");
        break;
case "151201": 
nanatool.insertAtCursor(theBox,"~\u05DE\u05E6\u05D4~");
        break;
case "glatt1": 
nanatool.insertAtCursor(theBox,"(:-))");
        break;
case "glatt2": 
nanatool.insertAtCursor(theBox,"(:-()");
        break;
case "glatt3": 
nanatool.insertAtCursor(theBox,"(0-:)");
        break;
case "glatt4": 
nanatool.insertAtCursor(theBox,"(;-))");
        break;
case "glatt5": 
nanatool.insertAtCursor(theBox,"(,:()");
        break;
case "glatt6": 
nanatool.insertAtCursor(theBox,"(8-))");
        break;
case "glatt7": 
nanatool.insertAtCursor(theBox,"(:-*)");
        break;
case "glatt8": 
nanatool.insertAtCursor(theBox,"(:-D)");
        break;
case "glatt9": 
nanatool.insertAtCursor(theBox,"(:-/)");
        break;
case "glatt10": 
nanatool.insertAtCursor(theBox,"(~\u05D0\u05D5\u05D4\u05D1~)");
        break;
case "glatt11": 
nanatool.insertAtCursor(theBox,"(~\u05D0\u05D3\u05D5\u05DD~)");
        break;
case "glatt12": 
nanatool.insertAtCursor(theBox,"(~\u05DB\u05D7\u05D5\u05DC~)");
        break;
case "glatt13": 
nanatool.insertAtCursor(theBox,"(~\u05DC\u05D9\u05E6\u05DF2~)");
        break;
case "future1": 
nanatool.insertAtCursor(theBox,"~\u05DE\u05D5\u05D6\u05D9\u05DC\u05D4~");
        break;
case "future2": 
nanatool.insertAtCursor(theBox,"~\u05E4\u05D9\u05D9\u05E8\u05E4\u05D5\u05E7\u05E1~");
        break;
case "sig1": 
nanatool.insertAtCursor(theBox,"\u05D4\u05D5\u05D3\u05E2\u05D4 \u05D6\u05D5 \u05E0\u05DB\u05EA\u05D1\u05D4 \u05D1\u05E2\u05D6\u05E8\u05EA http://forums.nana.co.il/Article/?ArticleID=153976  BananaTools");
        break;
case "sig2": 
nanatool.insertAtCursor(theBox,"\u05E8\u05E4\u05D5\u05D1\u05DC\u05D9\u05E7\u05EA \u05D1~\u05E0\u05E2\u05E0\u05E2~ - \u05E4\u05D5\u05E8\u05D5\u05DD  \u05D4\u05E6\u05DE\u05D7\u05D5\u05E0\u05D5\u05EA \u05D5\u05D4\u05D8\u05D1\u05E2\u05D5\u05E0\u05D5\u05EA \u05E9\u05DC\u05DA http://forums.nana.co.il/veg");
        break;
case "sig3": 
nanatool.insertAtCursor(theBox,"Get Firefox http://www.spreadfirefox.com/?q=affiliates&id=6254&t=1");
        break;
  	// End Smiles
        
      default : 
        var alertText = NanaTool_stringBundle.getString("nanatool.option.err");
        alert(alertText);
        
    }
  },

  insertAtCursorSetupHTML: function(myCommand, str_clipboard, str, theBox) {
    switch (myCommand){
        
      case "img":
        nanatool.insertAtCursor(theBox,"<img src=\"" + str_clipboard + "\"/>");
        break;
        
      case "imgalt":
        var alertText = NanaTool_stringBundle.getString("nanatool.img.alttext");
        nanatool.insertAtCursor(theBox,"<img src=\"" + str_clipboard + "\"" + " alt=\"" + prompt(alertText) + "\"/>");
        break;
        
      case "url":
        nanatool.insertAtCursor(theBox,"<a href=\"\">" + str + "</a>");
        break;
        
       case "urltitle":
        var alertText = NanaTool_stringBundle.getString("nanatool.url.title");
        nanatool.insertAtCursor(theBox,"<a href=\"\" title=\""+ prompt(alertText) + "\">" + str + "</a>");
        break;
        
      case "urlclip":
        nanatool.insertAtCursor(theBox,"<a href=\"" + str_clipboard + "\">" + str + "</a>");
        break;
        
      case "urlcliptitle":
        var alertText = NanaTool_stringBundle.getString("nanatool.url.title");
        nanatool.insertAtCursor(theBox,"<a href=\"" + str_clipboard + "\" title=\""+ prompt(alertText) + "\">" + str + "</a>");
        break;
        
      case "bold":
        nanatool.insertAtCursor(theBox,"<b>" + str + "</b>");
        break;
        
      case "italic":
        nanatool.insertAtCursor(theBox,"<i>" + str + "</i>");
        break;
        
      case "underline":
        nanatool.insertAtCursor(theBox,"<u>" + str + "</u>");
        break;
      
      case "strike":
        nanatool.insertAtCursor(theBox,"<strike>" + str + "</strike>");
        break;
      
      case "blockquote":
        nanatool.insertAtCursor(theBox,"<blockquote>" + str + "</blockquote>");
        break;
      
      case "list":
        var listElements = " ";
        var listString = "";
        while(listElements != "" && listElements != null){ 
          var alertText = NanaTool_stringBundle.getString("nanatool.list");
          listElements = prompt(alertText);
          if(listElements != "" && listElements != null ){
            listString = listString + "\n<li>" +listElements + "</li>";
          }
        }
        if(listElements != null){
          nanatool.insertAtCursor(theBox,"<ul>"  + listString + "</ul>");
        }
        break;  
        
      case "size":
        var re = [];
        var nanatoolsize = [NanaTool_Size];
        window.openDialog("chrome://nanatool/content/nanatoolsize.xul", "NanaToolSize","chrome,modal,centerscreen",re,nanatoolsize);
        if(re[0]){
          nanatool.insertAtCursor(theBox,"<font size=\"" + nanatoolsize[0] + "\">" + str + "</font>");
          NanaTool_Size = nanatoolsize[0];
        }
        break;

      case "color":
        var re = [];
        var nanatoolcolor = [NanaTool_Color];
        window.openDialog("chrome://nanatool/content/nanatoolcolor.xul", "NanaToolColor","chrome,modal,centerscreen",re,nanatoolcolor);
        if(re[0]){
          nanatool.insertAtCursor(theBox,"<font color=\"" + nanatoolcolor[0] + "\">" + str + "</font>");
          NanaTool_Color = nanatoolcolor[0];
        }
        break;
        
      default : 
        var alertText = NanaTool_stringBundle.getString("nanatool.option.err");
        alert(alertText);
    }
  },
  	insertAtCursorSetupXHTML: function(myCommand, str_clipboard, str, theBox) {
    switch (myCommand){
        
      case "img":
        nanatool.insertAtCursor(theBox,"<img src=\"" + str_clipboard + "\"/>");
        break;
        
      case "imgalt":
        var alertText = NanaTool_stringBundle.getString("nanatool.img.alttext");
        nanatool.insertAtCursor(theBox,"<img src=\"" + str_clipboard + "\"" + " alt=\"" + prompt(alertText) + "\"/>");
        break;
        
      case "url":
        nanatool.insertAtCursor(theBox,"<a href=\"\">" + str + "</a>");
        break;
        
       case "urltitle":
        var alertText = NanaTool_stringBundle.getString("nanatool.url.title");
        nanatool.insertAtCursor(theBox,"<a href=\"\" title=\""+ prompt(alertText) + "\">" + str + "</a>");
        break;
        
      case "urlclip":
        nanatool.insertAtCursor(theBox,"<a href=\"" + str_clipboard + "\">" + str + "</a>");
        break;
        
      case "urlcliptitle":
        var alertText = NanaTool_stringBundle.getString("nanatool.url.title");
        nanatool.insertAtCursor(theBox,"<a href=\"" + str_clipboard + "\" title=\""+ prompt(alertText) + "\">" + str + "</a>");
        break;
        
      case "bold":
        nanatool.insertAtCursor(theBox,"<strong>" + str + "</strong>");
        break;
        
      case "italic":
        nanatool.insertAtCursor(theBox,"<em>" + str + "</em>");
        break;
        
      case "underline":
        nanatool.insertAtCursor(theBox,"<ins>" + str + "</ins>");
        break;
      
      case "strike":
        nanatool.insertAtCursor(theBox,"<del>" + str + "</del>");
        break;
      
      case "blockquote":
        nanatool.insertAtCursor(theBox,"<blockquote>" + str + "</blockquote>");
        break;
      
      case "list":
        var listElements = " ";
        var listString = "";
        while(listElements != "" && listElements != null){ 
          var alertText = NanaTool_stringBundle.getString("nanatool.list");
          listElements = prompt(alertText);
          if(listElements != "" && listElements != null ){
            listString = listString + "\n<li>" +listElements + "</li>";
          }
        }
        if(listElements != null){
          nanatool.insertAtCursor(theBox,"<ul>"  + listString + "</ul>");
        }
        break;  
        
      case "size":
        var re = [];
        var nanatoolsize = [NanaTool_Size];
        window.openDialog("chrome://nanatool/content/nanatoolsize.xul", "NanaToolSize","chrome,modal,centerscreen",re,nanatoolsize);
        if(re[0]){
          nanatool.insertAtCursor(theBox,"<span style=\"font-size: " + nanatoolsize[0] + "\">" + str + "</span>");
          NanaTool_Size = nanatoolsize[0];
        }
        break;

      case "color":
        var re = [];
        var nanatoolcolor = [NanaTool_Color];
        window.openDialog("chrome://nanatool/content/nanatoolcolor.xul", "NanaToolColor","chrome,modal,centerscreen",re,nanatoolcolor);
        if(re[0]){
          nanatool.insertAtCursor(theBox,"<span style=\"color: " + nanatoolcolor[0] + "\">" + str + "</span>");
          NanaTool_Color = nanatoolcolor[0];
        }
        break;
        
      default : 
        var alertText = NanaTool_stringBundle.getString("nanatool.option.err");
        alert(alertText);
    }
  },
  
	insertAtCursor_old: function(myField, myValue) {
  // Function taken from http://www.alexking.org/blog/2003/06/02/inserting-at-the-cursor-using-javascript/
  // Modified to return cursor to correct place
    if (myField.selectionStart || myField.selectionStart == '0') {
      var startPos = myField.selectionStart;
      var endPos = myField.selectionEnd;
      myField.value = myField.value.substring(0, startPos)
      + myValue
      + myField.value.substring(endPos, myField.value.length);
      var cursorPos = endPos + myValue.length;
      myField.selectionStart = cursorPos;
      myField.selectionEnd = cursorPos;
    } 
    else {
      myField.value += myValue;
    }
  },
  
  //Thanks to Nick for pointing out this function
  insertAtCursor: function(theBox, aText) {
    try {
      var command = "cmd_insertText";
      var controller = document.commandDispatcher.getControllerForCommand(command);
      if (controller && controller.isCommandEnabled(command)) {
        controller = controller.QueryInterface(Components.interfaces.nsICommandController);
        var params = Components.classes["@mozilla.org/embedcomp/command-params;1"];
        params = params.createInstance(Components.interfaces.nsICommandParams);
        params.setStringValue("state_data", aText);
        controller.doCommandWithParams(command, params);
      }
    }catch (e) {
      dump("Can't do cmd_insertText! ");
      dump(e+"\n")
    }
  }
}

//http://www.xulplanet.com/references/xpcomref/ifaces/nsIPref.html
// Definitally the best way to use prefs, set's defaults, etc.
function getPrefNanaToolCompose() {
  if (!gPreferences) {
    try {
      gPreferences = Components.classes["@mozilla.org/preferences;1"].getService();
      gPreferences = gPreferences.QueryInterface(
        Components.interfaces.nsIPref);
    } catch (e) {}
  }

  return gPreferences;
}

//May not be needed, but just incase.
function NanaTool_setupDocument(aDoc)
{
  NanaTool_Document = aDoc;
  NanaTool_stringBundle = aDoc.getElementById("bbcstrings");
}

//Make sure nanatool loads on start-up of browser.
window.addEventListener('load', nanatool.init, false); 
